// -------------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSpTEhf[^ϊvOwb_t@C
// 
// 				Ver 3.20f
// 
// -------------------------------------------------------------------------------

#ifndef DX_SOUNDCONVERTWIN_H
#define DX_SOUNDCONVERTWIN_H

#include "../DxCompileConfig.h"

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxThread.h"

#include "DxUseCStrmBaseFilter.h"

#ifndef DX_NON_ACM
	#if defined( DX_GCC_COMPILE ) || defined( DX_GCC_COMPILE_4_9_2 ) || defined( DX_GCC_COMPILE_5_3_0 )
		#include <mmreg.h>
	#endif // defined( DX_GCC_COMPILE ) || defined( DX_GCC_COMPILE_4_9_2 ) || defined( DX_GCC_COMPILE_5_3_0 )
	#include <msacm.h>
#endif // DX_NON_ACM

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define SOUND_METHODTYPE_ACM				(SOUND_METHODTYPE_DEFAULT_NUM + 0)		// `blgp
#define SOUND_METHODTYPE_DSMP3				(SOUND_METHODTYPE_DEFAULT_NUM + 1)		// crgploRĐ
#define SOUND_METHODTYPE_MF					(SOUND_METHODTYPE_DEFAULT_NUM + 2)		// l@egp

// \̒` --------------------------------------------------------------------

#ifndef DX_NON_ACM

// #ifdef DX_GCC_COMPILE
struct D_HACMSTREAM__
{
	int unused ;
} ;

typedef struct D_HACMSTREAM__ *D_HACMSTREAM ;
typedef        D_HACMSTREAM   *D_LPHACMSTREAM ;

struct D_HACMOBJ__
{
	int unused ;
} ;
typedef struct D_HACMOBJ__     *D_HACMOBJ ;

typedef struct D_wavefilter_tag
{
	DWORD   cbStruct;           /* Size of the filter in bytes */
	DWORD   dwFilterTag;        /* filter type */
	DWORD   fdwFilter;          /* Flags for the filter (Universal Dfns) */
	DWORD   dwReserved[5];      /* Reserved for system use */
} D_WAVEFILTER;
typedef D_WAVEFILTER FAR  *D_LPWAVEFILTER;

#define D_MPEGLAYER3_WFX_EXTRA_BYTES			12
#define D_WAVE_FORMAT_MPEGLAYER3				0x0055 /* ISO/MPEG Layer3 Format Tag */

#define D_MPEGLAYER3_ID_UNKNOWN					0
#define D_MPEGLAYER3_ID_MPEG					1
#define D_MPEGLAYER3_ID_CONSTANTFRAMESIZE		2

typedef struct D_mpeglayer3waveformat_tag
{
	WAVEFORMATEX  wfx;
	WORD          wID;
	DWORD         fdwFlags;
	WORD          nBlockSize;
	WORD          nFramesPerBlock;
	WORD          nCodecDelay;
} D_MPEGLAYER3WAVEFORMAT ;

#define D_ACM_STREAMSIZEF_SOURCE				0x00000000L
#define D_ACM_STREAMSIZEF_DESTINATION			0x00000001L
#define D_ACM_STREAMSIZEF_QUERYMASK				0x0000000FL

#define D_ACM_METRIC_MAX_SIZE_FORMAT			50

#define D_ACM_STREAMCONVERTF_BLOCKALIGN			0x00000004
#define D_ACM_STREAMCONVERTF_START				0x00000010
#define D_ACM_STREAMCONVERTF_END				0x00000020

#ifdef  _WIN64
#define D__DRVRESERVED    15
#else
#define D__DRVRESERVED    10
#endif  // _WIN64

typedef struct D_tACMSTREAMHEADER
{
    DWORD           cbStruct;               // sizeof(D_ACMSTREAMHEADER)
    DWORD           fdwStatus;              // ACMSTREAMHEADER_STATUSF_*
    DWORD_PTR       dwUser;                 // user instance data for hdr
    LPBYTE          pbSrc;
    DWORD           cbSrcLength;
    DWORD           cbSrcLengthUsed;
    DWORD_PTR       dwSrcUser;              // user instance data for src
    LPBYTE          pbDst;
    DWORD           cbDstLength;
    DWORD           cbDstLengthUsed;
    DWORD_PTR       dwDstUser;              // user instance data for dst
    DWORD           dwReservedDriver[D__DRVRESERVED];   // driver reserved work space

} D_ACMSTREAMHEADER, *D_PACMSTREAMHEADER, FAR *D_LPACMSTREAMHEADER;
// #endif

// `blf[^ϊp\
struct SOUNDCONV_ACM
{
	WAVEFORMATEX				*Format ;				// ϊ̃tH[}bg
	D_HACMSTREAM				AcmStreamHandle[2]	;	// kꂽf[^ۂɎg`bl̃nh

	void						*SrcData ;				// ϊ̃f[^ꎞIɕۑĂ̈
	int							SrcDataSize ;			// ϊ̃f[^ꎞIɕۑĂ̈̃TCY
//	int							SrcDataValidSize ;		// ϊ̃f[^̗LȃTCY
	int							SrcDataPosition ;		// ϊ̃f[^̕ϊTCY
	int							DestDataSampleNum ;		// ϊ̃f[^̃Tv( -1:ȊȌꍇ̂ݗL )

	int							BeginSeekCompSrcSize ;	// V[N\ʒu܂ŃTuACMnhŕϊĂŁAɕϊĂ鈳kf[^̃TCY
	int							BeginSeekPosition ;		// V[N\ʒu܂ŃTuACMnhŕϊĂŁAɕϊĂWJf[^̃TCY(V[N\ʒu SOUNDCONV ֐ SeekLockPosition o[)
	void						*BeginSeekBuffer ;		// V[N\ʒu܂ŃTuACMnhŕϊĂŎgpobt@
} ;

#endif // DX_NON_ACM

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE

// crgloRf[^ϊŎgpobt@NX
class SOUNDCONV_DSMP3_BUF : public D_ISampleGrabberCB
{
public :
	struct SOUNDCONV			*SoundConvData ;		// f[^ϊp\̂ւ̃|C^

	ULONG __stdcall				AddRef() ;
	ULONG __stdcall				Release() ;

	HRESULT __stdcall			QueryInterface( REFIID riid, void ** ppv ) ;
	HRESULT __stdcall			SampleCB( double SampleTime, D_IMediaSample *pSample ) ;
	HRESULT __stdcall			BufferCB( double SampleTime, BYTE *pBuffer, long BufferLen ) ;
} ;

// crgloRf[^ϊp\
struct SOUNDCONV_DSMP3
{
	void						*PCMBuffer ;			// oblɕϊꂽf[^i[郁̈
	DWORD						PCMBufferSize ;			// oblobt@̃TCY
	DWORD						PCMValidDataSize ;		// LȂobl̃TCY
	DWORD						PCMDestCopySize ;		// {obt@ւ̃Rs[TCY
} ;

#endif  // DX_NON_DSHOW_MOVIE
#endif	// DX_NON_MOVIE

// TEhϊŜŎgpf[^\̂ Windows ɈˑĂ̍\
struct SOUNDCONVERTDATA_WIN
{
	int							Dummy ;
#ifndef DX_NON_ACM
	HMODULE						msacm32DLL ;					// msacm32DLL
	MMRESULT					( WINAPI *acmStreamOpenFunc            )( D_LPHACMSTREAM phas, HACMDRIVER had, LPWAVEFORMATEX pwfxSrc, LPWAVEFORMATEX pwfxDst, D_LPWAVEFILTER pwfltr, DWORD dwCallback, DWORD dwInstance, DWORD fdwOpen );
	MMRESULT					( WINAPI *acmFormatSuggestFunc         )( HACMDRIVER had, LPWAVEFORMATEX pwfxSrc, LPWAVEFORMATEX pwfxDst, DWORD cbwfxDst, DWORD fdwSuggest );
	MMRESULT					( WINAPI *acmStreamCloseFunc           )( D_HACMSTREAM has, DWORD fdwClose );
	MMRESULT					( WINAPI *acmMetricsFunc               )( D_HACMOBJ hao, UINT uMetric, LPVOID pMetric );
	MMRESULT					( WINAPI *acmStreamPrepareHeaderFunc   )( D_HACMSTREAM has, D_LPACMSTREAMHEADER pash, DWORD fdwPrepare );
	MMRESULT					( WINAPI *acmStreamConvertFunc         )( D_HACMSTREAM has, D_LPACMSTREAMHEADER pash, DWORD fdwConvert );
	MMRESULT					( WINAPI *acmStreamUnprepareHeaderFunc )( D_HACMSTREAM has, D_LPACMSTREAMHEADER pash, DWORD fdwUnprepare );
	MMRESULT					( WINAPI *acmStreamSizeFunc            )( D_HACMSTREAM has, DWORD cbInput, LPDWORD pdwOutputBytes, DWORD fdwSize );
#endif
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

#ifndef DX_NON_ACM
extern	int SetupSoundConvert_ACM(            struct SOUNDCONV *SoundConv ) ;								// `blgpt@C̃ZbgAbvs( [] -1:G[ )
extern	int SetupSoundConvert_MP3(            struct SOUNDCONV *SoundConv ) ;								// loRt@C̃ZbgAbvs( [] -1:G[ )
extern	int TerminateSoundConvert_ACM(        struct SOUNDCONV *SoundConv ) ;								// `blgpt@Čns
extern	int ConvertProcessSoundConvert_ACM(   struct SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//extern	int SetTimeSoundConvert_ACM(      struct SOUNDCONV *SoundConv, int Time ) ;						// ϊʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert_ACM(    struct SOUNDCONV *SoundConv, int SampleTime ) ;				// ϊ̈ʒuύX( TvP )
extern	int GetSoundConvertDestSize_Fast_ACM( struct SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂
#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
extern	int TerminateSoundConvert_DSMP3(        struct SOUNDCONV *SoundConv ) ;								// MP3gpt@Čns
extern	int ConvertProcessSoundConvert_DSMP3(   struct SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//extern	int SetTimeSoundConvert_DSMP3(      struct SOUNDCONV *SoundConv, int Time ) ;					// ϊʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert_DSMP3(    struct SOUNDCONV *SoundConv, int SampleTime ) ;				// ϊ̈ʒuύX( TvP )
extern	int GetSoundConvertDestSize_Fast_DSMP3( struct SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂
#endif
#endif
#endif

#ifndef DX_NON_MEDIA_FOUNDATION
extern	int SetupSoundConvert_MF(            SOUNDCONV *SoundConv ) ;										// Media Foundation gpt@C̃ZbgAbvs( [] -1:G[ )
extern	int TerminateSoundConvert_MF(        SOUNDCONV *SoundConv ) ;										// Media Foundation gpt@Čns
extern	int ConvertProcessSoundConvert_MF(   SOUNDCONV *SoundConv ) ;										// ϊ̃obt@Ƀf[^[
//extern	int SetTimeSoundConvert_MF(      SOUNDCONV *SoundConv, int Time ) ;								// ϊʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert_MF(    SOUNDCONV *SoundConv, int SampleTime ) ;						// ϊ̈ʒuύX( TvP )
extern	int GetSoundConvertDestSize_Fast_MF( SOUNDCONV *SoundConv ) ;										// ϊ̑}̃f[^TCY𓾂
#endif // DX_NON_MEDIA_FOUNDATION

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_SOUNDCONVERTWIN_H
